module merten.cgi.htmltemplate;

private import file, string;

/**
 * A very very simple html template engine.
 *
 * It expects to find keywords in between curly braces '{}'
 */
class HTMLTemplate
{
    char[] buffer;
    char[][char[]] vars;

    /** expects the filename of the template file */
    this(char[] tmplFile)
    {
        assert(tmplFile.length > 0);
        try
        {
            this.buffer = (char[])file.read(tmplFile);
        }
        catch
        {
            throw new Error("Couldn't open: "~tmplFile);
        }
    }

    /** replaces key with value */
    void addVar(char[] key, char[] value)
    {
        this.vars[key] = value;
    }

    private char[] parse()
    {
        char[] result = this.buffer;
        char[][] keys = this.vars.keys;

        for(int i = 0; i < keys.length; i++)
        {
            result = string.replace(result, "{"~keys[i]~"}", this.vars[keys[i]]);
        }

        return result;
    }

    char[] getHTML()
    {
        return this.parse();
    }
}